local functions = require"functions"
local lume = require"libs.lume"
local Grid = require"src.Grid"
local Physics = require"src.Physics"
local Camera = require"src.Camera"
local physics_test = {}


local camera1 = Camera.general:new()

local world1 = Physics.world:new()

local ball1 = Physics.ball:new()
ball1.add = {size = 300}

local block1 = Physics.block:new()
block1.add = {width = 10000, name = "floor"}

local block2 = Physics.block:new()
block2.add = {name = "block2", width = 200, x = 800, y = 200, angular_velocity = 1, set_x_linear_velocity = 50}

local block3 = Physics.block:new()
block3.add = {name = "block2", width = 200, x = 400, y = 200, set_x_linear_velocity = 200, x_distance = 3000}


local block4 = Physics.block:new()
block4.add = {width = 500, x = 0, y = -300, set_y_linear_velocity = 200, x_distance = 100}


functions.load_all_entities(physics_test, camera1, world1, ball1, block1, block2, block3, block3, block4)


return physics_test