local Timer = require 'libs.Timer'
local enemy = {
	{"component", "enemy components", 
		{
		name = "enemy",
		rotation_speed = 8,
		speed = 180,
		ease = "linear",
		time_to_change_direction = 3,
		direction = 5,
		tween_duration = 4,
		is_sensor = false,
		starting_interval = 3,
		ending_interval = 8,
		linear_velocity = {x = 0, y = 0},
		directions = {},
		collision_category = 0000000000000010,
    	collision_mask = 0000000000000010,
    	collision_group = 0,
    	seed = 9
		},

	},
	{"love load", "load enemy components",
		{function(e)
    		e.randomness = love.math.newRandomGenerator()
			e.timer = Timer(e.seed)
			e.directions = {{-e.speed, 0}, {-e.speed, -e.speed}, {0, -e.speed}, {e.speed, -e.speed}, {e.speed, 0}, {e.speed, e.speed}, {e.speed, 0}, {-e.speed, e.speed}}
			e.randomness:setSeed(os.time()+e.seed)
			e.timer:every({e.randomness:random(2, 3), e.randomness:random(5, 9)}, function() e.direction = e.randomness:random(1, 8) e.timer:tween(e.tween_duration, e.linear_velocity, {x = e.directions[e.direction][1], y = e.directions[e.direction][2]}, e.ease) end)
		end}
	},
	{"love update", "move enemy",
		{function(e)
			e.timer:update(references.delta_time)
			e.body:setLinearVelocity(e.linear_velocity.x, e.linear_velocity.y)
		end}
	},
	{"love draw", "test enemy", 
		{function(e)
			lg.print(e.linear_velocity.x)
			lg.print(e.linear_velocity.y, 0, 20)
			lg.print(tostring(e.direction), 0, e.seed)
		end}
	},
	{"love update", "keep enemy inside boundaries", 
		{function(e)
			if references.a_begin_contact == e.fixture and
				references.b_begin_contact == "limit" then

			end
		end}
	}


}

return enemy